#include "controls.h"
#include "yosumin.h"
#include "utils.h"

#include <nds.h>

YosuminControls::YosuminControls()
{
    pair = false;
    startpair = false;
}

void YosuminControls::update(void)
{
    touchPosition touch;

    scanKeys();

    if ( keysHeld() & KEY_TOUCH ) {
	touching = true;
	touch = touchReadXY();
	x = touch.px;
	y = touch.py;
    } else
	touching = false;

    if ( keysDown() & KEY_TOUCH ) {
	if ( x >= 16 && x < 176 && y >= 16 && y < 176 ) {
	    x1 = ( x - 16 ) / 16;
	    y1 = ( y - 16 ) / 16;
	    startpair = true;
	}
    }

    if ( keysUp() & KEY_TOUCH ) {
	if ( startpair && x >= 16 && x < 176 && y >= 16 && y < 176 ) {
	    x2 = ( x - 16 ) / 16;
	    y2 = ( y - 16 ) / 16;
	    pair = true;
	    order(x1, y1, x2, y2);
	}
	startpair = false;
    }
}

bool YosuminControls::hasPair(void)
{
    return pair;
}

void YosuminControls::getPair(int & rx1, int & ry1, int & rx2, int & ry2)
{
    pair = false;

    rx1 = x1;
    ry1 = y1;

    rx2 = x2;
    ry2 = y2;
}

bool YosuminControls::isTouching(void)
{
    return touching;
}

void YosuminControls::getCurrent(int & rx, int & ry)
{
    rx = x;
    ry = y;
}

bool YosuminControls::isInPair(void)
{
    /*
    int tmp;

    tmp = ( x - 16 ) / 16;
    if ( x < 0 || x >= Yosumin::width )
	return false;

    tmp = ( y - 16 ) / 16;
    if ( y < 0 || y >= Yosumin::height )
	return false;
	*/

    return startpair;
}
