#ifndef _DISPLAY_H_
#define _DISPLAY_H_

#include "yosumin.h"
#include "controls.h"
#include "numbers.h"

#include <nds.h>

class Display {

    Yosumin * yosumin;
    YosuminControls * controls;

    Numbers * timeLeft;
    Numbers * score;
    Numbers * level;
    Numbers * squares[Yosumin::maxColors];

    int animbonus;

public:
    Display(Yosumin * yosumin, YosuminControls * controls);

    // General display function
    void display(void);

    // Animations
    void gameover(void);
    void congrats(void);
    void touchToStart(void);
    void clear(int x1, int y1, int x2, int y2, bool subGetSad);
    void clear(void);
    void appear(int x1, int y1, int x2, int y2, int subGotSad);
    void appear(void);

    // Icons
    void timebonus(void);

    // Borders
    void makeBoxTiles(u16 * vram);
    void drawGameBorder(void);
    
    void drawSelection(void);
    void clearSelection(void);

    void setAllNormal(void);
};

#endif
