#include "numbers.h"
#include "utils.h"

Numbers::Numbers(SpriteEntry * s, int x, int y, int nbchars, int spriteZaroo)
{
    int i;

    characters = s;
    this->nbchars = nbchars;
    this->spriteZaroo = spriteZaroo;
    
    this->div = 1;
    for ( i = nbchars ; i > 1 ; i-- )
	this->div *= 10;

    for ( i = 0 ; i < nbchars ; i++ ) {
	s[i].attribute[0] = OBJ_Y(y);
	s[i].attribute[1] = OBJ_X((i%10)*16 + x) | ATTR1_SIZE_16;
	s[i].attribute[2] = spriteZaroo | ATTR2_PALETTE(15); // Initially zaroO
    }
}

Numbers::~Numbers()
{
    // Reset sprites
    for ( int i = 0 ; i < nbchars ; i++ )
	characters[i].attribute[1] = 256; // Off screen
}

void Numbers::set(int value)
{
    int i, div = this->div;
    SpriteEntry * tmp = characters;

    if ( value < 0 )
	return;

    for ( i = nbchars ; i > 0 ; i--, tmp++, div /= 10 )
	tmp->attribute[2] = ATTR2_TILE(spriteZaroo + (value/div) % 10) | tmp->attribute[2] & (~1023);
}
