#ifndef _YOSUMIN_H_
#define _YOSUMIN_H_

class Yosumin {

public:
    static const int width = 10;
    static const int height = 10;
    static const int maxColors = 5;
    // In seconds
    static const int initialPlayTime = 31;
    static const int levelBonusPlayTime = 10;
    static const int clearBonusPlayTime = 3;
    static const int firstLevelOffset = 11;

private:
    int grid[height][width];
    int eat[maxColors];
    int level;
    int x1, x2, y1, y2;
    unsigned int time, score;

public:
    Yosumin();
    void reset(void);

    int getMazeValue(int x, int y);
    int getEatValue(int position);

    // Returns true if player has made a square
    bool guess(int x1, int y1, int x2, int y2);
    // Make new random points in last guessed square
    void update(void);
    // Returns true if yosumin is finished
    bool goToNextLevel(void);
    // And goes
    void nextLevel(void);

    // Decrements timer
    void timeDown(void);
    // Tell if game is finished
    bool timeUp(void);

    unsigned int getTime(void);
    unsigned int getScore();
    unsigned int getLevel();
    unsigned int getColors();

    void play(void);
};

#endif
